import math

real_width = 8
fake_width = 13



def first_word(fake_idx):
    # Calculate first index

    # bit index in an unrolled array
    bit_index = fake_width*fake_idx
    print("bit index is", bit_index)

    # starting word of memory is

    starting_word = math.floor(bit_index/real_width)

    print("starting memory word", starting_word)

    starting_bit_index = bit_index % real_width

    print("starting bit index", starting_bit_index)

    unwrapped_end_bit_index = (fake_width + starting_bit_index) - 1

    print("unwrapped_end_bit_index", unwrapped_end_bit_index)

    additional_words = math.floor(unwrapped_end_bit_index/real_width)

    print("additional_words", additional_words)

    end_bit_index = unwrapped_end_bit_index % real_width

    print("end_bit_index", end_bit_index)

    # print the fetch pattern:

    # There are three kinds of fetches:
    
    # Memory index         left bit index             right bit index
    # Start word           starting_bit_index         max(unwrapped_end_bit_index, real_width)
    # Middle words         0                          real_width
    # End word             0                          end_bit_index


    # We special-case the first fetch outside of the loop, since it always happens
    # and has special-case logic used nowhere else.
    bits_snarfed = 0

    if (additional_words == 0):
        # Start word           starting_bit_index         unwrapped_end_bit_index
        assert(unwrapped_end_bit_index == end_bit_index)
        print("single obligatory read of word", starting_word, "from bit index", starting_bit_index, "to", unwrapped_end_bit_index)
        bits_snarfed += unwrapped_end_bit_index - starting_bit_index + 1
        print("Snarfed", bits_snarfed)

    else:
        current_word = starting_word
        # Start word           starting_bit_index         real_width

        print("first obligatory read of word", current_word, "from bit index", starting_bit_index, "to", real_width - 1)
        bits_snarfed += (real_width - 1) - starting_bit_index + 1
        print("Snarfed", bits_snarfed)


        # if additional_words !=0, we start the loop. 
        # The microsequencer then iterate over the "middle words", and if there's a partial slice needed to be taken
        # from the end word (end_bit_index !=0) , we do that as well before returning

        additional_words_fetched = 0

        # Middle words         0                          real_width
        while(additional_words_fetched != (additional_words-1)):
            additional_words_fetched += 1
            current_word += 1
            print("FULLWORD read of word", current_word, "from bit index", 0, "to", real_width - 1)
            bits_snarfed += (real_width - 1) - 0 + 1
            print("Snarfed", bits_snarfed)

        current_word += 1
        print("SPECIAL last fetch of word", current_word, "from bit index", 0, "to", end_bit_index)
        bits_snarfed += (end_bit_index) + 1
        print("Snarfed", bits_snarfed)

    print("FINAL Snarfed", bits_snarfed)

for i in range(4):
    print("fake index is", i)
    first_word(i)
    print("\n")